/* --COPYRIGHT--,BSD
 * Copyright (c) 2017, Texas Instruments Incorporated
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * *  Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * *  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * *  Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * --/COPYRIGHT--*/
//******************************************************************************

//******************************************************************************

#include "driverlib.h"
#include <msp430.h>
#include "Board.h"
#include "Defines.h"
#include "main.h"

//unsigned char DATAWR_ARRAY[MAX_PACKET_SIZE_WR] = { 0xC0,0x10,0x0,0x93,0xAB,0xCD,0xEF,0xAB } ;
//unsigned char DATAWR_ARRAY[MAX_PACKET_SIZE_WR] = { 0xC0,0x90,0x0,0x93 } ;


void main(void)
{

    cmd_received = 0;
    InitSystem();


          MEMADDR_PROG = 2;
          // Enable global interrupts
          __enable_interrupt();


    // NVM Write and Read Testing Routine


//    int i_nvm;
//
//    for (i_nvm = 0 ; i_nvm <64;i_nvm++)
//    {
//        NVMData[i_nvm]=i_nvm;
//    }
//    NVMAddress = 0x00;
//    NVMData[0] = 0xFF;
//     MEMADDR_PROG = 11;
//     MCC_Decode();



    //NVM Read Testing Routine

//
//        NVMAddress = 0x00;
//        MEMADDR_PROG = 14;
//        MCC_Decode();



   //MCC Write & Read Testing : Uncomment DATAWR_ARRAY definition from above














    while (1)
    {

        if(cmd_received == 1)
        {
            cmd_received =0;
            EndOfWrite = 1;
              EUSCI_B_I2C_initMasterParam param = {0};
              param.selectClockSource = EUSCI_B_I2C_CLOCKSOURCE_SMCLK;
              param.i2cClk = CS_getSMCLK();
              param.dataRate = EUSCI_B_I2C_SET_DATA_RATE_100KBPS;
              param.byteCounterThreshold = 0;
              param.autoSTOPGeneration = EUSCI_B_I2C_NO_AUTO_STOP;
              EUSCI_B_I2C_initMaster(EUSCI_I2C_BASE, &param);
                EUSCI_B_I2C_setMode(EUSCI_I2C_BASE,
                        EUSCI_B_I2C_TRANSMIT_MODE
                        );

                //Enable I2C Module to start operations
                EUSCI_B_I2C_enable(EUSCI_I2C_BASE);

                EUSCI_B_I2C_clearInterrupt(EUSCI_I2C_BASE,
                        EUSCI_B_I2C_TRANSMIT_INTERRUPT0 +
                        EUSCI_B_I2C_NAK_INTERRUPT
                        );
                //Enable master Receive interrupt
                EUSCI_B_I2C_enableInterrupt(EUSCI_I2C_BASE,
                        EUSCI_B_I2C_RECEIVE_INTERRUPT0 +
                        EUSCI_B_I2C_TRANSMIT_INTERRUPT0 +
                        EUSCI_B_I2C_NAK_INTERRUPT
                        );
            MCC_Decode();

        }

    }
}

//******************************************************************************
//
//This is the USCI_A0 interrupt vector service routine.
//
//******************************************************************************
#if defined(__TI_COMPILER_VERSION__) || defined(__IAR_SYSTEMS_ICC__)
#pragma vector= USCI_VECTOR
__interrupt
#elif defined(__GNUC__)
__attribute__((interrupt(USCI_A0_VECTOR)))
#endif
#ifdef __MSP430FR2355AEP_BRD__
void EUSCI_A1_ISR(void)
#endif
#ifdef __MSP430FR2355_LAUNCHPAD__
void EUSCI_A0_ISR(void)
#endif
{
    // Enable GIE to allow nesting
    __bis_SR_register(GIE);

#ifdef __MSP430FR2355AEP_BRD__
    switch(__even_in_range(UCA1IV,USCI_UART_UCTXCPTIFG))
#endif
#ifdef __MSP430FR2355_LAUNCHPAD__
    switch(__even_in_range(UCA0IV,USCI_UART_UCTXCPTIFG))
#endif
    {
        case USCI_NONE: break;
        case USCI_UART_UCRXIFG:
            RXData = EUSCI_A_UART_receiveData(EUSCI_BASE);



            /* Parse received command immediately */
                       receivedDataCommand(RXData);

                        ErrorCount++;
                       if(ErrorCount == 4000)
                               ErrorCount = 0;
            GPIO_toggleOutputOnPin(
                       GPIO_PORT,
                       GPIO_PIN
                       );
            break;
       case USCI_UART_UCTXIFG: break;
       case USCI_UART_UCSTTIFG: break;
       case USCI_UART_UCTXCPTIFG: break;
    }
}

//******************************************************************************
//
//This is the USCI_B0 interrupt vector service routine for I2C Master
//
//******************************************************************************


#if defined(__TI_COMPILER_VERSION__) || defined(__IAR_SYSTEMS_ICC__)
#pragma vector= USCI_I2C_VECTOR//USCI_B1_VECTOR
__interrupt
#elif defined(__GNUC__)
__attribute__((interrupt(USCI_B0_VECTOR)))
#endif
#ifdef __MSP430FR2355AEP_BRD__
void USCIB1_ISR(void)
#endif
#ifdef __MSP430FR2355_LAUNCHPAD__
void USCIB0_ISR(void)
#endif
{
__delay_cycles(1600);
    if(MCC_RW == WRITE) //I2C Write
   {
#ifdef __MSP430FR2355AEP_BRD__
    switch(__even_in_range(UCB1IV, USCI_I2C_UCBIT9IFG))
#endif
#ifdef __MSP430FR2355_LAUNCHPAD__
    switch(__even_in_range(UCB0IV, USCI_I2C_UCBIT9IFG))
#endif
        {
        case USCI_NONE:             // No interrupts break;
            break;
        case USCI_I2C_UCALIFG:      // Arbitration lost
            break;
        case USCI_I2C_UCNACKIFG:    // NAK received (master only)
            //resend start if NACK
            {
                            if (resent_count <= MAX_Resent_Count)
                                        {
                                           EUSCI_B_I2C_masterSendStart(EUSCI_I2C_BASE);
                                           resent_count++;

                                        }

                               else
                               {
                                   resent_count = 0;
                                   MEMADDR_PROG=0;
                                   EndOfWrite = 1;
                                   EUSCI_B_I2C_masterSendMultiByteStop(EUSCI_I2C_BASE);
                               }
            break;

            }
        case USCI_I2C_UCTXIFG0:     // TXIFG0
            // Check TX byte counter
            {
            switch (MEMADDR_PROG)
            {
            case 7:
                {

                        TXData_I2C++;
                        if (TXData_I2C<MCC_Packet_Size)
                        {

                            EUSCI_B_I2C_masterSendMultiByteNext(EUSCI_I2C_BASE, DATAWR_ARRAY[TXData_I2C]);
                            // Decrement TX byte counter
                            resent_count = 0;
                        }
                        else
                        {
                            EUSCI_B_I2C_masterSendMultiByteStop(EUSCI_I2C_BASE);
                            TXData_I2C = 0;
                            resent_count = 0;
                            EndOfWrite = 1;
                            MEMADDR_PROG=2;

                            // Exit LPM0
                            __bic_SR_register_on_exit(CPUOFF);
                }
                break;
                }

            case 11:
                {
                           TXData_I2C++;
                           if (TXData_I2C==1)
                           {
                               EUSCI_B_I2C_masterSendMultiByteNext(EUSCI_I2C_BASE, (NVMAddress & 0xFF00) >> 8);  //Send address
                           }
                           else if (TXData_I2C==2)
                           {

                               EUSCI_B_I2C_masterSendMultiByteNext(EUSCI_I2C_BASE, (NVMAddress & 0xFF));

                           }
                           else if(TXData_I2C<=64+2 && NVMWrite == 1)
                           {
                               EUSCI_B_I2C_masterSendMultiByteNext(EUSCI_I2C_BASE, NVMData[TXData_I2C-3]); //Send 64 byte data
                           }
                           else //end of NVM Write
                           {
                               EUSCI_B_I2C_masterSendMultiByteStop(EUSCI_I2C_BASE);
                                                  TXData_I2C = 0;
                                                  resent_count = 0;
                                                  EndOfWrite = 1;

               }

                break;
                }


            case 14:
                       {
                              TXData_I2C++;
                              if (TXData_I2C==1)
                              {
                                  EUSCI_B_I2C_masterSendMultiByteNext(EUSCI_I2C_BASE, (NVMAddress & 0xFF00) >> 8);  //Send address
                              }
                              else if (TXData_I2C==2)
                              {

                                  EUSCI_B_I2C_masterSendMultiByteNext(EUSCI_I2C_BASE, (NVMAddress & 0xFF));

                              }
                              else if(TXData_I2C<=64+2 && NVMWrite == 1)
                              {
                                  EUSCI_B_I2C_masterSendMultiByteNext(EUSCI_I2C_BASE, NVMData[TXData_I2C-3]); //Send 64 byte data
                              }
                              else //end of NVM Write
                              {
                                  EUSCI_B_I2C_masterSendMultiByteStop(EUSCI_I2C_BASE);
                                                     TXData_I2C = 0;
                                                     resent_count = 0;
                                                     EndOfWrite = 1;

                              }

                           break;
                       }

            default:
                break;
            }
           
        }
        default:
            break;
  }
    }

    else    //I2C Read
    {
#ifdef __MSP430FR2355AEP_BRD__
        switch(__even_in_range(UCB1IV, USCI_I2C_UCBIT9IFG))
#endif
#ifdef __MSP430FR2355_LAUNCHPAD__
        switch(__even_in_range(UCB0IV, USCI_I2C_UCBIT9IFG))
#endif
            {
                case USCI_NONE:             // No interrupts break;
                    break;
                case USCI_I2C_UCALIFG:      // Arbitration lost
                    break;
                case USCI_I2C_UCNACKIFG:    // NAK received (master only)
                    EUSCI_B_I2C_masterSendMultiByteStop(EUSCI_I2C_BASE);
                    {
                    if (resent_count <= MAX_Resent_Count)
                             {
                                EUSCI_B_I2C_masterSendStart(EUSCI_I2C_BASE);
                                resent_count++;

                             }

                    else
                    {
                        resent_count = 0;
                        MEMADDR_PROG=0;
                        EUSCI_B_I2C_masterSendMultiByteStop(EUSCI_I2C_BASE);
                    }

                    break;
                    }
                case USCI_I2C_UCSTTIFG:     // START condition detected with own address (slave mode only)
                    break;
                case USCI_I2C_UCSTPIFG:     // STOP condition detected (master & slave mode)
                    break;
                case USCI_I2C_UCRXIFG3:     // RXIFG3
                    break;
                case USCI_I2C_UCTXIFG3:     // TXIFG3
                    break;
                case USCI_I2C_UCRXIFG2:     // RXIFG2
                    break;
                case USCI_I2C_UCTXIFG2:     // TXIFG2
                    break;
                case USCI_I2C_UCRXIFG1:     // RXIFG1
                    break;
                case USCI_I2C_UCTXIFG1:     // TXIFG1
                    break;
                case USCI_I2C_UCRXIFG0:     // RXIFG0
                                       // Get RX data
                {

                            resent_count = 0;
                            switch (MEMADDR_PROG)
							{
                            case 7:
                            {

                            DATARD_ARRAY[RXCOUNT_I2C+5] = EUSCI_B_I2C_masterReceiveSingle(
                                                    EUSCI_I2C_BASE
                                    );
                            RXCOUNT_I2C++;

                          if (RXCOUNT_I2C  == (DLEN + CRC_EN)-1) {
                              EUSCI_B_I2C_masterSendMultiByteStop(EUSCI_I2C_BASE);   //Send Stop Bit

                          }

                          if (RXCOUNT_I2C  == (DLEN + CRC_EN)) {
                              MEMADDR_PROG=10;
                              RXCOUNT_I2C = 0;
                              __bic_SR_register_on_exit(CPUOFF); // Exit LPM0
                          }

                          break;
                            }

                            case 11:
                            {

                                NVMData[RXCOUNT_I2C] = EUSCI_B_I2C_masterReceiveSingle(
                                                                           EUSCI_I2C_BASE
                                                           );
                                                   RXCOUNT_I2C++;

                                                 if(RXCOUNT_I2C == 63)
                                                 {
                                                     EUSCI_B_I2C_masterSendMultiByteStop(EUSCI_I2C_BASE);   //Send Stop Bit
                                                 }

                                                 if (RXCOUNT_I2C  == 64)
                                                 {

                                                     MEMADDR_PROG=12;
                                                     RXCOUNT_I2C = 0;
                                                     __bic_SR_register_on_exit(CPUOFF); // Exit LPM0
                                                 }

                                break;
                            }

							default:
                            break; // Vector 24: RXIFG0 break;
							}
				}
                case USCI_I2C_UCTXIFG0:     // TXIFG0
                            break;
                case USCI_I2C_UCBCNTIFG:    // Byte count limit reached (UCBxTBCNT)
                            break;
                case USCI_I2C_UCCLTOIFG:    // Clock low timeout - clock held low too long
                            break;
                case USCI_I2C_UCBIT9IFG:    // Generated on 9th bit of a transmit (for debugging)
                            break;
                default:
                            break;

                 
            }
    }

}



